
#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>

#include "packet.h"

int _preplace(const uint8_t * const src, const int len, uint8_t * const dst, const char * const needle, const char * const replace) {
	// if no replace needed just copy over the packet
	if(!needle) {
		memcpy(dst, src, len);
		return(len);
	}

	// search the needle in the source
	const uint8_t *occurence = memmem(src, len, needle, strlen(needle));
	if(occurence == NULL) {
		fprintf(stderr, "needle '%s' not found in source '%s'\n", needle, src);
		return(0);
	}

	// copy the source part till the needle into the destination
	int p = 0;
	memcpy(dst+p, src, occurence-src);
	p += occurence-src;

	// add the replace part to the destination
	memcpy(dst+p, replace, strlen(replace));
	p += strlen(replace);

	// add the rest of the source to the destination
	occurence += strlen(needle);
	memcpy(dst+p, occurence, len-(occurence-src));
	p += len-(occurence-src);
	
	return(p);
}

